package org.greenstone.gsdl3.gs3build.doctypes;

import org.greenstone.gsdl3.gs3build.FileCrawlObserver;

import java.io.File;
import java.net.URL;

public class RecogniserManager implements FileCrawlObserver
{
  RecogniserInterface list[];
  int                 used;
  int                 size;

  public RecogniserManager()
  { this.list = new RecogniserInterface[10];
    this.used = 0;
    this.size = 10;
  }

  public void addRecogniser(RecogniserInterface recogniser)
  { this.ensureCapacity(this.used + 1);

    this.list[this.used] = recogniser;
    this.used ++;
  }

  public void processFile(URL url)
  { boolean result;

    for (int r = 0; r < this.used; r ++)
    { if (list[r].parseDocument(url)) {
        break;
      }
    }
  }
 
  public void processFile(File file)
  { try {
      URL url = new URL("file://"+file.toString());
      
      this.processFile(url);
    }
    catch (java.net.MalformedURLException ex)
    {
      System.out.println(ex);
    }
  }

  private void ensureCapacity(int size)
  { while (size >= this.size)
    { RecogniserInterface newList [] = new RecogniserInterface[this.size*2];
      this.size *= 2;
      System.arraycopy(this.list, 0, newList, 0, this.size);
      this.list = newList;
    }
  }
}
