package org.greenstone.gsdl3.gs3build.doctypes;

import java.io.File;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 *  A pretty basic DocumentInterface class - just able to
 *  provide unsophisticated access to the document as plain
 *  text, and no attempt at metadata extraction
 */

public class TextDocument extends AbstractDocument
{
  public static final String TEXT_DOCUMENT_TYPE = "Text";

  public TextDocument(DocumentID id)
  { super(id);
  }

  public TextDocument(URL url)
  { super(url);
  }

  public String getDocumentType()
  { return TEXT_DOCUMENT_TYPE;
  }

  /**
   *  A pretty minimal and lazy document text extraction process.
   */
  public String getDocumentText()
  { return DocumentLoader.getAsString((URL) this.fileSet.getFile(0).getLocation());
  }
}
